--
-- liftaxleAnim
-- Specialization for liftaxleAnim
--
-- monteur1

liftaxleAnim = {};

function liftaxleAnim.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end

function liftaxleAnim:load(xmlFile)
    self.liftaxle1Animation = getXMLString(self.xmlFile, "vehicle.liftaxle1#animationName");
    if self.liftaxle1Animation ~= nil then
		self.liftaxle1StartProzent = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.liftaxle1#startProzent"), 0);	
		self.liftaxleCapacity = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.fillUnits.fillUnit#capacity"), 1);
    end
    self.liftaxle2Animation = getXMLString(self.xmlFile, "vehicle.liftaxle2#animationName");
    if self.liftaxle2Animation ~= nil then
		self.liftaxle2StartProzent = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.liftaxle2#startProzent"), 0);	
		self.liftaxleCapacity = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.fillUnits.fillUnit#capacity"), 1);
    end	
	
	self.liftaxle1_Lifted = {};
	self.liftaxle2_Lifted = {};
	self.liftaxleVehicleAttached = false
end

function liftaxleAnim:postLoad(savegame)
    if self.liftaxle1Animation ~= nil then
		local startLiftaxle1Value = self.liftaxleCapacity / 100 * self.liftaxle1StartProzent
		local aktfilllevel = self:getFillLevel(fillType) 
		if aktfilllevel > startLiftaxle1Value then
			self:playAnimation(self.liftaxle1Animation, -20, nil, true); --Liftachse nach unten
			self.liftaxle1_Lifted = false
		else
			self:playAnimation(self.liftaxle1Animation, 20, nil, true); --Liftachse nach oben
			self.liftaxle1_Lifted = true
        end
    end
    if self.liftaxle2Animation ~= nil then
		local startLiftaxle2Value = self.liftaxleCapacity / 100 * self.liftaxle2StartProzent
		local aktfilllevel = self:getFillLevel(fillType) 
		if aktfilllevel > startLiftaxle2Value then
			self:playAnimation(self.liftaxle2Animation, -20, nil, true); --Liftachse nach unten
			self.liftaxle2_Lifted = false
		else
			self:playAnimation(self.liftaxle2Animation, 20, nil, true); --Liftachse nach oben
			self.liftaxle2_Lifted = true
        end
    end	
end

function liftaxleAnim:getSaveAttributesAndNodes(nodeIdent)
end

function liftaxleAnim:readStream(streamId, connection)
end

function liftaxleAnim:writeStream(streamId, connection)
end

function liftaxleAnim:update(dt)
	if self.liftaxleVehicleAttached == true then
		if self.liftaxle1Animation ~= nil then
			local startLiftaxle1Value = self.liftaxleCapacity / 100 * self.liftaxle1StartProzent
			local aktfilllevel = self:getFillLevel(fillType) 
			if aktfilllevel > startLiftaxle1Value then
				if self.liftaxle1_Lifted == true then			
					self:playAnimation(self.liftaxle1Animation, -1, self:getAnimationTime(self.liftaxle1Animation), false); --Liftachse nach unten
					self.liftaxle1_Lifted = false
				end					
			else
				if self.liftaxle1_Lifted == false then										
					self:playAnimation(self.liftaxle1Animation, 1, self:getAnimationTime(self.liftaxle1Animation), false); --Liftachse nach oben
					self.liftaxle1_Lifted = true
				end														
			end
		end
		if self.liftaxle2Animation ~= nil then
			local startLiftaxle2Value = self.liftaxleCapacity / 100 * self.liftaxle2StartProzent
			local aktfilllevel = self:getFillLevel(fillType) 
			if aktfilllevel > startLiftaxle2Value then
				if self.liftaxle2_Lifted == true then						
					self:playAnimation(self.liftaxle2Animation, -1, self:getAnimationTime(self.liftaxle2Animation), false); --Liftachse nach unten
					self.liftaxle2_Lifted = false
				end										
			else
				if self.liftaxle2_Lifted == false then							
					self:playAnimation(self.liftaxle2Animation, 1, self:getAnimationTime(self.liftaxle2Animation), false); --Liftachse nach oben
					self.liftaxle2_Lifted = true
				end									
			end
		end
    end
end

function liftaxleAnim:draw()
end

function liftaxleAnim:delete()
end;

function liftaxleAnim:mouseEvent(posX, posY, isDown, isUp, button)
end;

function liftaxleAnim:keyEvent(unicode, sym, modifier, isDown)
end;

function liftaxleAnim:onAttach()
	self.liftaxleVehicleAttached = true
end; 	

function liftaxleAnim:onDetach()
	self.liftaxleVehicleAttached = false
end;